# -*- coding: utf-8 -*-
#
# This file is part of the SKA PST SEND project
#
# Distributed under the terms of the BSD 3-clause new license.
# See LICENSE for more info.

"""Module class for interacting with the DPD API Pod."""
from __future__ import annotations

import logging
import pathlib

import requests
import yaml

INGEST_NEW_METADATA_API_ENDPOINT: str = "ingestnewmetadata"
"""The DPD API endpoint to ingest a new data product."""

DATA_PRODUCT_METADATA_API_ENDPOINT: str = "dataproductmetadata"
"""The DPD API endpoint to retrieve a metadata product."""


class DpdApiClient:
    """Class used for interacting with the DataProduct Dashboard API."""

    def __init__(
        self: DpdApiClient,
        endpoint: str,
        logger: logging.Logger | None = None,
    ) -> None:
        """Initialize the DpdApiClient with API endpoint.

        :param endpoint: The endpoint of the API server. Consists of domain name and port number
        :param logger: the logger instance to use.
        """
        self._endpoint = endpoint
        self.logger = logger or logging.getLogger(__name__)

    def ingest_new_metadata(self: DpdApiClient, metadata_file: str | pathlib.Path) -> str:
        """
        Ingest new metadata into the DPD.

        :param metadata_file: the full path the metadata file.
        :type metadata_file: str | pathlib.Path
        :return: the UUID generated by the DPD for the current data product.
        :rtype: str
        """
        with open(metadata_file, "r") as f:
            metadata: dict = yaml.safe_load(f)

        url = f"{self._endpoint}/{INGEST_NEW_METADATA_API_ENDPOINT}"
        self.logger.debug(f"Ingesting new metadata with {url=}")
        response = requests.post(url, headers={"accept": "application/json"}, json=metadata)
        response_body = response.json()
        if response.ok:
            self.logger.debug(f"DPD added metadata. {response_body=}")
            # API returns a list, first item is a JSON object that has "uuid" as a key
            # 2nd is the status code 201
            return response_body[0]["uuid"]
        else:
            self.logger.warning(
                f"DPD failed to add dataproduct metadata calling /{INGEST_NEW_METADATA_API_ENDPOINT}."
                f" {response_body=}"
            )
            raise Exception(
                "DPD failed to add dataproduct metadata. Status code:"
                f" {response.status_code}, {response_body=}"
            )

    def data_product_metadata(self: DpdApiClient, uuid: str) -> dict:
        """
        Get the data product metadata based for the given the UUID.

        :param uuid: the UUID of the metadata product
        :type uuid: str
        :return: the data product metadata based for the given the UUID.
        :rtype: dict
        """
        url = f"{self._endpoint}/{DATA_PRODUCT_METADATA_API_ENDPOINT}"
        self.logger.debug(f"Ingesting new metadata with {url=}")
        response = requests.post(url, headers={"accept": "application/json"}, json={"uuid": uuid})
        if response.ok:
            self.logger.debug(f"Found metadata for {uuid=}")
            return response.json()
        else:
            raise Exception(
                f"Failed to retrieve DPD associated with {uuid=}. Status code: {response.status_code}"
            )

    # Property and setter for the API endpoint
    @property
    def endpoint(self) -> str:
        """Getter method for the API endpoint."""
        return self._endpoint

    @endpoint.setter
    def endpoint(self, value: str) -> None:
        """Setter method for the API endpoint."""
        self._endpoint = value
